Index: pjproject/trunk/tests/pjsua/mod_sipp.py
===================================================================
--- pjproject/trunk/tests/pjsua/mod_sipp.py	(revision 4182)
+++ pjproject/trunk/tests/pjsua/mod_sipp.py	(revision 4183)
@@ -17,4 +17,7 @@
     G_INUNIX = True
 
+# /dev/null handle, for redirecting output when SIPP is not in background mode
+FDEVNULL = None
+
 # SIPp executable path and param
 #SIPP_PATH = '"C:\\Program Files (x86)\\Sipp_3.2\\sipp.exe"'
@@ -25,6 +28,6 @@
 # On non-BG mode, on win, it needs env var: "TERMINFO=c:\cygwin\usr\share\terminfo"
 # TODO: on unix with BG mode, waitpid() always fails, need to be fixed
-#SIPP_BG_MODE = True
-SIPP_BG_MODE = not G_INUNIX
+SIPP_BG_MODE = False
+#SIPP_BG_MODE = not G_INUNIX
 
 # Will be updated based on configuration file (a .py file whose the same name as SIPp XML file)
@@ -80,5 +83,8 @@
 	sipp_proc = subprocess.Popen(fullcmd, bufsize=0, stdin=subprocess.PIPE, stdout=subprocess.PIPE, shell=G_INUNIX, universal_newlines=False)
     else:
-	sipp_proc = subprocess.Popen(fullcmd, shell=G_INUNIX)
+	# redirect output to NULL
+	global FDEVNULL
+	FDEVNULL  = open(os.devnull, 'w')
+	sipp_proc = subprocess.Popen(fullcmd, shell=G_INUNIX, stdout=FDEVNULL, stderr=FDEVNULL)
 
     if not SIPP_BG_MODE:
@@ -115,5 +121,7 @@
 def wait_sipp(sipp):
     if not SIPP_BG_MODE:
+	global FDEVNULL
 	sipp.wait()
+	FDEVNULL.close()
 	return sipp.returncode
 
@@ -176,7 +184,25 @@
     # Ideally the poll should be done contiunously until SIPp process is
     # terminated.
-    ua[0].expect(inc_const.STDOUT_REFRESH, raise_on_error = False)
+    for ua_idx in range(len(ua)):
+	ua[ua_idx].expect(inc_const.STDOUT_REFRESH, raise_on_error = False)
 
     return ua_err_st
+
+
+def sipp_err_to_str(err_code):
+    if err_code == 0:
+	return "All calls were successful"
+    elif err_code == 1:
+	return "At least one call failed"
+    elif err_code == 97:
+	return "exit on internal command. Calls may have been processed"
+    elif err_code == 99:
+	return "Normal exit without calls processed"
+    elif err_code == -1:
+	return "Fatal error (timeout)"
+    elif err_code == -2:
+	return "Fatal error binding a socket"
+    else:
+	return "Unknown error"
 
 
@@ -199,5 +225,6 @@
 
     if sipp_ret_code:
-        raise TestError("SIPp returned error " + str(sipp_ret_code))
+	rc = ctypes.c_byte(sipp_ret_code).value
+        raise TestError("SIPp returned error " + str(rc) + ": " + sipp_err_to_str(rc))
 
 
Index: pjproject/trunk/tests/pjsua/run.py
===================================================================
--- pjproject/trunk/tests/pjsua/run.py	(revision 4182)
+++ pjproject/trunk/tests/pjsua/run.py	(revision 4183)
@@ -144,5 +144,5 @@
 			# Print the line if echo is ON
 			if self.echo:
-				print self.name + ": " + line,
+				print self.name + ": " + line.rstrip()
 			# Trap assertion error
 			if self.ra.search(line) != None:
Index: pjproject/trunk/tests/pjsua/runall.py
===================================================================
--- pjproject/trunk/tests/pjsua/runall.py	(revision 4182)
+++ pjproject/trunk/tests/pjsua/runall.py	(revision 4183)
@@ -94,5 +94,5 @@
 			resume_script=sys.argv[1]
 			sys.argv.pop(0)
-			sys.argv.pop(1)
+			sys.argv.pop(0)
 	        else:
 	                sys.argv.pop(0)
@@ -120,13 +120,16 @@
 			shell_cmd = sys.argv[1]
 			sys.argv.pop(0)
-			sys.argv.pop(1)
+			sys.argv.pop(0)
                 else:
                         sys.argv.pop(0)
                         sys.stderr.write("Error: argument value required")
                         sys.exit(1)
+	else:
+		# should be run.py options
+		break
 
 
 # Generate arguments for run.py
-argv_st = " ".join(sys.argv)
+argv_st = " ".join(sys.argv) + " "
 
 # Init vars
Index: pjproject/trunk/tests/pjsua/scripts-sipp/transfer-attended.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/transfer-attended.py	(revision 4182)
+++ pjproject/trunk/tests/pjsua/scripts-sipp/transfer-attended.py	(revision 4183)
@@ -12,4 +12,5 @@
 		 [0, "", "m"],
 		 [0, "", "sip:localhost:5062"],
+		 [0, const.STATE_CALLING, ""],
 		 [1, const.EVENT_INCOMING_CALL, "a"],
 		 [1, "", "200"],
@@ -25,4 +26,5 @@
 		 [1, "", "m"],
 		 [1, "", "sip:localhost:5064"],
+		 [1, const.STATE_CALLING, ""],
 		 [2, const.EVENT_INCOMING_CALL, "a"],
 		 [2, "", "200"],
@@ -47,5 +49,4 @@
 		 [0, const.MEDIA_ACTIVE, ""],
 		 [2, const.MEDIA_ACTIVE, ""],
-		 [1, "", " "],
-		 [1, "have 0 active call", ""],
+		 [1, const.STATE_DISCONNECTED, ""]
 		]
Index: pjproject/trunk/tests/pjsua/scripts-sipp/transfer-unattended.py
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/transfer-unattended.py	(revision 4182)
+++ pjproject/trunk/tests/pjsua/scripts-sipp/transfer-unattended.py	(revision 4183)
@@ -12,4 +12,5 @@
 		 [0, "", "m"],
 		 [0, "", "sip:localhost:5062"],
+		 [0, const.STATE_CALLING, ""],
 		 [1, const.EVENT_INCOMING_CALL, "a"],
 		 [1, "", "200"],
@@ -26,5 +27,4 @@
 		 [2, const.MEDIA_ACTIVE, ""],
 		 [1, "call transfered successfully", ""],
-		 [1, "", " "],
-		 [1, "have 0 active call", ""],
+		 [1, const.STATE_DISCONNECTED, ""]
 		]
Index: pjproject/trunk/tests/pjsua/scripts-sipp/uas-forked-100rel.xml
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/uas-forked-100rel.xml	(revision 4182)
+++ pjproject/trunk/tests/pjsua/scripts-sipp/uas-forked-100rel.xml	(revision 4183)
@@ -23,7 +23,7 @@
   <recv request="INVITE" crlf="true">
    <action>
-    <ereg regexp="branch=([0-9a-zA-Z\-]*)"
+    <ereg regexp="branch=([^;]*)"
           search_in="hdr"
-	  header="Via"
+          header="Via"
           assign_to="1,2"/>
     <assign assign_to="1" variable="2"/>
Index: pjproject/trunk/tests/pjsua/scripts-sipp/uas-forked-200.xml
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/uas-forked-200.xml	(revision 4182)
+++ pjproject/trunk/tests/pjsua/scripts-sipp/uas-forked-200.xml	(revision 4183)
@@ -23,7 +23,7 @@
   <recv request="INVITE" crlf="true">
    <action>
-    <ereg regexp="branch=([0-9a-zA-Z]*)"
+    <ereg regexp="branch=([^;]*)"
           search_in="hdr"
-	  header="Via"
+          header="Via"
           assign_to="1,2"/>
     <assign assign_to="1" variable="2"/>
Index: pjproject/trunk/tests/pjsua/scripts-sipp/uas-inv-answered-with-srtp.xml
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/uas-inv-answered-with-srtp.xml	(revision 4183)
+++ pjproject/trunk/tests/pjsua/scripts-sipp/uas-inv-answered-with-srtp.xml	(revision 4183)
@@ -0,0 +1,77 @@
+<?xml version="1.0" encoding="ISO-8859-1" ?>
+<!DOCTYPE scenario SYSTEM "sipp.dtd">
+
+<!-- This program is free software; you can redistribute it and/or      -->
+<!-- modify it under the terms of the GNU General Public License as     -->
+<!-- published by the Free Software Foundation; either version 2 of the -->
+<!-- License, or (at your option) any later version.                    -->
+<!--                                                                    -->
+<!-- This program is distributed in the hope that it will be useful,    -->
+<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of     -->
+<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      -->
+<!-- GNU General Public License for more details.                       -->
+<!--                                                                    -->
+<!-- You should have received a copy of the GNU General Public License  -->
+<!-- along with this program; if not, write to the                      -->
+<!-- Free Software Foundation, Inc.,                                    -->
+<!-- 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA             -->
+<!--                                                                    -->
+<!--                 Sipp default 'uas' scenario.                       -->
+<!--                                                                    -->
+
+<scenario name="Basic UAS responder">
+  <!-- By adding rrs="true" (Record Route Sets), the route sets         -->
+  <!-- are saved and used for following messages sent. Useful to test   -->
+  <!-- against stateful SIP proxies/B2BUAs.                             -->
+  <recv request="INVITE" crlf="true">
+  </recv>
+
+  <!-- The '[last_*]' keyword is replaced automatically by the          -->
+  <!-- specified header if it was present in the last message received  -->
+  <!-- (except if it was a retransmission). If the header was not       -->
+  <!-- present or if no message has been received, the '[last_*]'       -->
+  <!-- keyword is discarded, and all bytes until the end of the line    -->
+  <!-- are also discarded.                                              -->
+  <!--                                                                  -->
+  <!-- If the specified header was present several times in the         -->
+  <!-- message, all occurences are concatenated (CRLF seperated)        -->
+  <!-- to be used in place of the '[last_*]' keyword.                   -->
+
+  <send retrans="500">
+    <![CDATA[
+
+      SIP/2.0 200 OK
+      [last_Via:]
+      [last_From:]
+      [last_To:];tag=[call_number]
+      [last_Call-ID:]
+      [last_CSeq:]
+      Contact: <sip:sipp@[local_ip]:[local_port]>
+      Content-Type: application/sdp
+
+      v=0
+      o=- 3441953879 3441953879 IN IP4 192.168.0.15
+      s=pjmedia
+      c=IN IP4 192.168.0.15
+      t=0 0
+      m=audio 4004 RTP/SAVP 0 101
+      a=rtpmap:0 PCMU/8000
+      a=rtpmap:101 telephone-event/8000
+      a=fmtp:101 0-15
+      a=crypto:1 AES_CM_128_HMAC_SHA1_80 inline:D4Mf5fIPqxwse/lLrVc2XhLk7NSL6JI0k0Jps4Br
+
+    ]]>
+  </send>
+
+  <recv request="ACK" crlf="true">
+  </recv>
+
+
+  <!-- definition of the response time repartition table (unit is ms)   -->
+  <ResponseTimeRepartition value="10, 20, 30, 40, 50, 100, 150, 200"/>
+
+  <!-- definition of the call length repartition table (unit is ms)     -->
+  <CallLengthRepartition value="10, 50, 100, 500, 1000, 5000, 10000"/>
+
+</scenario>
+
Index: pjproject/trunk/tests/pjsua/scripts-sipp/uas-invite.xml
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/uas-invite.xml	(revision 4182)
+++ 	(revision )
@@ -1,77 +1,0 @@
-<?xml version="1.0" encoding="ISO-8859-1" ?>
-<!DOCTYPE scenario SYSTEM "sipp.dtd">
-
-<!-- This program is free software; you can redistribute it and/or      -->
-<!-- modify it under the terms of the GNU General Public License as     -->
-<!-- published by the Free Software Foundation; either version 2 of the -->
-<!-- License, or (at your option) any later version.                    -->
-<!--                                                                    -->
-<!-- This program is distributed in the hope that it will be useful,    -->
-<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of     -->
-<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      -->
-<!-- GNU General Public License for more details.                       -->
-<!--                                                                    -->
-<!-- You should have received a copy of the GNU General Public License  -->
-<!-- along with this program; if not, write to the                      -->
-<!-- Free Software Foundation, Inc.,                                    -->
-<!-- 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA             -->
-<!--                                                                    -->
-<!--                 Sipp default 'uas' scenario.                       -->
-<!--                                                                    -->
-
-<scenario name="Basic UAS responder">
-  <!-- By adding rrs="true" (Record Route Sets), the route sets         -->
-  <!-- are saved and used for following messages sent. Useful to test   -->
-  <!-- against stateful SIP proxies/B2BUAs.                             -->
-  <recv request="INVITE" crlf="true">
-  </recv>
-
-  <!-- The '[last_*]' keyword is replaced automatically by the          -->
-  <!-- specified header if it was present in the last message received  -->
-  <!-- (except if it was a retransmission). If the header was not       -->
-  <!-- present or if no message has been received, the '[last_*]'       -->
-  <!-- keyword is discarded, and all bytes until the end of the line    -->
-  <!-- are also discarded.                                              -->
-  <!--                                                                  -->
-  <!-- If the specified header was present several times in the         -->
-  <!-- message, all occurences are concatenated (CRLF seperated)        -->
-  <!-- to be used in place of the '[last_*]' keyword.                   -->
-
-  <send retrans="500">
-    <![CDATA[
-
-      SIP/2.0 200 OK
-      [last_Via:]
-      [last_From:]
-      [last_To:];tag=[call_number]
-      [last_Call-ID:]
-      [last_CSeq:]
-      Contact: <sip:sipp@[local_ip]:[local_port]>
-      Content-Type: application/sdp
-
-      v=0
-      o=- 3441953879 3441953879 IN IP4 192.168.0.15
-      s=pjmedia
-      c=IN IP4 192.168.0.15
-      t=0 0
-      m=audio 4004 RTP/SAVP 0 101
-      a=rtpmap:0 PCMU/8000
-      a=rtpmap:101 telephone-event/8000
-      a=fmtp:101 0-15
-      a=crypto:1 AES_CM_128_HMAC_SHA1_80 inline:D4Mf5fIPqxwse/lLrVc2XhLk7NSL6JI0k0Jps4Br
-
-    ]]>
-  </send>
-
-  <recv request="ACK" crlf="true">
-  </recv>
-
-
-  <!-- definition of the response time repartition table (unit is ms)   -->
-  <ResponseTimeRepartition value="10, 20, 30, 40, 50, 100, 150, 200"/>
-
-  <!-- definition of the call length repartition table (unit is ms)     -->
-  <CallLengthRepartition value="10, 50, 100, 500, 1000, 5000, 10000"/>
-
-</scenario>
-
Index: pjproject/trunk/tests/pjsua/scripts-sipp/uas-prack_fork.xml
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/uas-prack_fork.xml	(revision 4182)
+++ pjproject/trunk/tests/pjsua/scripts-sipp/uas-prack_fork.xml	(revision 4183)
@@ -23,6 +23,7 @@
   <recv request="INVITE" crlf="true">
    <action>
-    <ereg regexp="branch=([0-9a-zA-Z]*)"
-          search_in="msg"
+    <ereg regexp="branch=([^;]*)"
+          search_in="hdr"
+          header="Via"
           assign_to="3"/>
     <ereg regexp="CSeq: ([0-9a-zA-Z ]*)"
Index: pjproject/trunk/tests/pjsua/scripts-sipp/uas-reinv-and-ack(same-branch)-without-sdp.xml
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/uas-reinv-and-ack(same-branch)-without-sdp.xml	(revision 4182)
+++ 	(revision )
@@ -1,118 +1,0 @@
-<?xml version="1.0" encoding="ISO-8859-1" ?>
-<!DOCTYPE scenario SYSTEM "sipp.dtd">
-
-<!-- This program is free software; you can redistribute it and/or      -->
-<!-- modify it under the terms of the GNU General Public License as     -->
-<!-- published by the Free Software Foundation; either version 2 of the -->
-<!-- License, or (at your option) any later version.                    -->
-<!--                                                                    -->
-<!-- This program is distributed in the hope that it will be useful,    -->
-<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of     -->
-<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      -->
-<!-- GNU General Public License for more details.                       -->
-<!--                                                                    -->
-<!-- You should have received a copy of the GNU General Public License  -->
-<!-- along with this program; if not, write to the                      -->
-<!-- Free Software Foundation, Inc.,                                    -->
-<!-- 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA             -->
-<!--                                                                    -->
-<!--                 Sipp default 'uas' scenario.                       -->
-<!--                                                                    -->
-
-<scenario name="Sending re-INVITE and ACK (with same branch) without SDP (#1045)">
-  <!-- By adding rrs="true" (Record Route Sets), the route sets         -->
-  <!-- are saved and used for following messages sent. Useful to test   -->
-  <!-- against stateful SIP proxies/B2BUAs.                             -->
-
-  <recv request="INVITE" crlf="true">
-    <action>
-	<ereg regexp=".*" search_in="hdr" header="From" assign_to="3"/>
-	<ereg regexp="sip:(.*)>" search_in="hdr" header="Contact" assign_to="4,5"/>
-        <assign assign_to="4" variable="5" />
-    </action>
-  </recv>
-
-  <send retrans="500">
-    <![CDATA[
-
-      SIP/2.0 200 OK
-      [last_Via:]
-      [last_From:]
-      [last_To:]
-      [last_Call-ID:]
-      [last_CSeq:]
-      Contact: sip:sipp@[local_ip]:[local_port]
-      Content-Type: application/sdp
-      Content-Length: [len]
-
-      v=0
-      o=- 3441953879 3441953879 IN IP4 192.168.0.15
-      s=pjmedia
-      c=IN IP4 192.168.0.15
-      t=0 0
-      m=audio 4004 RTP/AVP 0
-
-    ]]>
-  </send>
-
-  <recv request="ACK" crlf="true">
-  </recv>
-
-  <pause milliseconds="2000"/>
-
-  <send retrans="500">
-    <![CDATA[
-
-      INVITE sip:[$5] SIP/2.0
-      Via: SIP/2.0/[transport] [local_ip]:[local_port];branch=z9hG4bK-same-branch
-      From: sipp  <sip:sipp@[local_ip]:[local_port]>;tag=[call_number]
-      To[$3]
-      Call-ID: [call_id]
-      Cseq: 1 INVITE
-      Contact: sip:sipp@[local_ip]:[local_port]
-      Max-Forwards: 70
-      Content-Length: 0
-
-    ]]>
-  </send>
-
-  <recv response="100"
-        optional="true">
-  </recv>
-
-  <recv response="180" optional="true">
-  </recv>
-
-  <recv response="200" rtd="true">
-  </recv>
-
-  <send>
-    <![CDATA[
-
-      ACK sip:[$5] SIP/2.0
-      Via: SIP/2.0/[transport] [local_ip]:[local_port];branch=z9hG4bK-same-branch
-      From: sipp  <sip:sipp@[local_ip]:[local_port]>;tag=[call_number]
-      To[$3]
-      Call-ID: [call_id]
-      Cseq: 1 ACK
-      Contact: sip:sipp@[local_ip]:[local_port]
-      Max-Forwards: 70
-      Content-Length: 0
-
-    ]]>
-  </send>
-
-
-  <!-- Keep the call open for a while in case the 200 is lost to be     -->
-  <!-- able to retransmit it if we receive the BYE again.               -->
-  <pause milliseconds="4000"/>
-
-
-  <!-- definition of the response time repartition table (unit is ms)   -->
-  <ResponseTimeRepartition value="10, 20, 30, 40, 50, 100, 150, 200"/>
-
-  <!-- definition of the call length repartition table (unit is ms)     -->
-  <CallLengthRepartition value="10, 50, 100, 500, 1000, 5000, 10000"/>
-
-</scenario>
-
Index: pjproject/trunk/tests/pjsua/scripts-sipp/uas-reinv-and-ack-same-branch-without-sdp.xml
===================================================================
--- pjproject/trunk/tests/pjsua/scripts-sipp/uas-reinv-and-ack-same-branch-without-sdp.xml	(revision 4183)
+++ pjproject/trunk/tests/pjsua/scripts-sipp/uas-reinv-and-ack-same-branch-without-sdp.xml	(revision 4183)
@@ -0,0 +1,118 @@
+<?xml version="1.0" encoding="ISO-8859-1" ?>
+<!DOCTYPE scenario SYSTEM "sipp.dtd">
+
+<!-- This program is free software; you can redistribute it and/or      -->
+<!-- modify it under the terms of the GNU General Public License as     -->
+<!-- published by the Free Software Foundation; either version 2 of the -->
+<!-- License, or (at your option) any later version.                    -->
+<!--                                                                    -->
+<!-- This program is distributed in the hope that it will be useful,    -->
+<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of     -->
+<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      -->
+<!-- GNU General Public License for more details.                       -->
+<!--                                                                    -->
+<!-- You should have received a copy of the GNU General Public License  -->
+<!-- along with this program; if not, write to the                      -->
+<!-- Free Software Foundation, Inc.,                                    -->
+<!-- 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA             -->
+<!--                                                                    -->
+<!--                 Sipp default 'uas' scenario.                       -->
+<!--                                                                    -->
+
+<scenario name="Sending re-INVITE and ACK (with same branch) without SDP (#1045)">
+  <!-- By adding rrs="true" (Record Route Sets), the route sets         -->
+  <!-- are saved and used for following messages sent. Useful to test   -->
+  <!-- against stateful SIP proxies/B2BUAs.                             -->
+
+  <recv request="INVITE" crlf="true">
+    <action>
+	<ereg regexp=".*" search_in="hdr" header="From" assign_to="3"/>
+	<ereg regexp="sip:(.*)>" search_in="hdr" header="Contact" assign_to="4,5"/>
+        <assign assign_to="4" variable="5" />
+    </action>
+  </recv>
+
+  <send retrans="500">
+    <![CDATA[
+
+      SIP/2.0 200 OK
+      [last_Via:]
+      [last_From:]
+      [last_To:]
+      [last_Call-ID:]
+      [last_CSeq:]
+      Contact: sip:sipp@[local_ip]:[local_port]
+      Content-Type: application/sdp
+      Content-Length: [len]
+
+      v=0
+      o=- 3441953879 3441953879 IN IP4 192.168.0.15
+      s=pjmedia
+      c=IN IP4 192.168.0.15
+      t=0 0
+      m=audio 4004 RTP/AVP 0
+
+    ]]>
+  </send>
+
+  <recv request="ACK" crlf="true">
+  </recv>
+
+  <pause milliseconds="2000"/>
+
+  <send retrans="500">
+    <![CDATA[
+
+      INVITE sip:[$5] SIP/2.0
+      Via: SIP/2.0/[transport] [local_ip]:[local_port];branch=z9hG4bK-same-branch
+      From: sipp  <sip:sipp@[local_ip]:[local_port]>;tag=[call_number]
+      To[$3]
+      Call-ID: [call_id]
+      Cseq: 1 INVITE
+      Contact: sip:sipp@[local_ip]:[local_port]
+      Max-Forwards: 70
+      Content-Length: 0
+
+    ]]>
+  </send>
+
+  <recv response="100"
+        optional="true">
+  </recv>
+
+  <recv response="180" optional="true">
+  </recv>
+
+  <recv response="200" rtd="true">
+  </recv>
+
+  <send>
+    <![CDATA[
+
+      ACK sip:[$5] SIP/2.0
+      Via: SIP/2.0/[transport] [local_ip]:[local_port];branch=z9hG4bK-same-branch
+      From: sipp  <sip:sipp@[local_ip]:[local_port]>;tag=[call_number]
+      To[$3]
+      Call-ID: [call_id]
+      Cseq: 1 ACK
+      Contact: sip:sipp@[local_ip]:[local_port]
+      Max-Forwards: 70
+      Content-Length: 0
+
+    ]]>
+  </send>
+
+
+  <!-- Keep the call open for a while in case the 200 is lost to be     -->
+  <!-- able to retransmit it if we receive the BYE again.               -->
+  <pause milliseconds="4000"/>
+
+
+  <!-- definition of the response time repartition table (unit is ms)   -->
+  <ResponseTimeRepartition value="10, 20, 30, 40, 50, 100, 150, 200"/>
+
+  <!-- definition of the call length repartition table (unit is ms)     -->
+  <CallLengthRepartition value="10, 50, 100, 500, 1000, 5000, 10000"/>
+
+</scenario>
+