Index: pjproject/trunk/pjsip/src/test/tsx_uac_test.c
===================================================================
--- pjproject/trunk/pjsip/src/test/tsx_uac_test.c	(revision 3553)
+++ pjproject/trunk/pjsip/src/test/tsx_uac_test.c	(revision 4208)
@@ -160,5 +160,5 @@
 static void tsx_user_on_tsx_state(pjsip_transaction *tsx, pjsip_event *e)
 {
-    if (pj_strcmp2(&tsx->branch, TEST1_BRANCH_ID)==0) {
+    if (pj_stricmp2(&tsx->branch, TEST1_BRANCH_ID)==0) {
 	/*
 	 * Transaction with TEST1_BRANCH_ID should terminate with transaction
@@ -214,5 +214,5 @@
 	}
 
-    } else if (pj_strcmp2(&tsx->branch, TEST2_BRANCH_ID)==0) {
+    } else if (pj_stricmp2(&tsx->branch, TEST2_BRANCH_ID)==0) {
 	/*
 	 * Transaction with TEST2_BRANCH_ID should terminate with transport error.
@@ -232,5 +232,5 @@
 	}
 
-    } else if (pj_strcmp2(&tsx->branch, TEST3_BRANCH_ID)==0) {
+    } else if (pj_stricmp2(&tsx->branch, TEST3_BRANCH_ID)==0) {
 	/*
 	 * This test terminates the transaction while resolver is still
@@ -257,5 +257,5 @@
 	}
 
-    } else if (pj_strcmp2(&tsx->branch, TEST4_BRANCH_ID)==0) {
+    } else if (pj_stricmp2(&tsx->branch, TEST4_BRANCH_ID)==0) {
 	/* 
 	 * This test simulates transport failure after several 
@@ -285,5 +285,5 @@
 
 
-    } else if (pj_strcmp2(&tsx->branch, TEST5_BRANCH_ID)==0) {
+    } else if (pj_stricmp2(&tsx->branch, TEST5_BRANCH_ID)==0) {
 	/* 
 	 * This test simulates transport failure after several 
@@ -313,5 +313,5 @@
 
 
-    } else if (pj_strcmp2(&tsx->branch, TEST6_BRANCH_ID)==0) {
+    } else if (pj_stricmp2(&tsx->branch, TEST6_BRANCH_ID)==0) {
 	/* 
 	 * Successfull non-INVITE transaction.
@@ -356,5 +356,5 @@
 	}
 
-    } else if (pj_strcmp2(&tsx->branch, TEST7_BRANCH_ID)==0) {
+    } else if (pj_stricmp2(&tsx->branch, TEST7_BRANCH_ID)==0) {
 	/* 
 	 * Successfull non-INVITE transaction.
@@ -409,5 +409,5 @@
 
 
-    } else if (pj_strcmp2(&tsx->branch, TEST8_BRANCH_ID)==0) {
+    } else if (pj_stricmp2(&tsx->branch, TEST8_BRANCH_ID)==0) {
 	/* 
 	 * Failed INVITE transaction.
@@ -469,5 +469,5 @@
 
 
-    } else if (pj_strcmp2(&tsx->branch, TEST9_BRANCH_ID)==0) {
+    } else if (pj_stricmp2(&tsx->branch, TEST9_BRANCH_ID)==0) {
 	/* 
 	 * Failed INVITE transaction with provisional response.
@@ -584,5 +584,5 @@
 static pj_bool_t msg_receiver_on_rx_request(pjsip_rx_data *rdata)
 {
-    if (pj_strcmp2(&rdata->msg_info.via->branch_param, TEST1_BRANCH_ID) == 0) {
+    if (pj_stricmp2(&rdata->msg_info.via->branch_param, TEST1_BRANCH_ID) == 0) {
 	/*
 	 * The TEST1_BRANCH_ID test performs the verifications for transaction
@@ -652,5 +652,5 @@
 
     } else
-    if (pj_strcmp2(&rdata->msg_info.via->branch_param, TEST4_BRANCH_ID) == 0) {
+    if (pj_stricmp2(&rdata->msg_info.via->branch_param, TEST4_BRANCH_ID) == 0) {
 	/*
 	 * The TEST4_BRANCH_ID test simulates transport failure after several
@@ -673,5 +673,5 @@
 
     } else
-    if (pj_strcmp2(&rdata->msg_info.via->branch_param, TEST5_BRANCH_ID) == 0) {
+    if (pj_stricmp2(&rdata->msg_info.via->branch_param, TEST5_BRANCH_ID) == 0) {
 	/*
 	 * The TEST5_BRANCH_ID test simulates user terminating the transaction
@@ -704,5 +704,5 @@
 
     } else
-    if (pj_strcmp2(&rdata->msg_info.via->branch_param, TEST6_BRANCH_ID) == 0) {
+    if (pj_stricmp2(&rdata->msg_info.via->branch_param, TEST6_BRANCH_ID) == 0) {
 	/*
 	 * The TEST6_BRANCH_ID test successfull non-INVITE transaction.
@@ -729,5 +729,5 @@
 
     } else
-    if (pj_strcmp2(&rdata->msg_info.via->branch_param, TEST7_BRANCH_ID) == 0) {
+    if (pj_stricmp2(&rdata->msg_info.via->branch_param, TEST7_BRANCH_ID) == 0) {
 	/*
 	 * The TEST7_BRANCH_ID test successfull non-INVITE transaction
@@ -779,5 +779,5 @@
 
     } else
-    if (pj_strcmp2(&rdata->msg_info.via->branch_param, TEST8_BRANCH_ID) == 0) {
+    if (pj_stricmp2(&rdata->msg_info.via->branch_param, TEST8_BRANCH_ID) == 0) {
 	/*
 	 * The TEST8_BRANCH_ID test failed INVITE transaction.
@@ -842,5 +842,5 @@
 
     } else
-    if (pj_strcmp2(&rdata->msg_info.via->branch_param, TEST9_BRANCH_ID) == 0) {
+    if (pj_stricmp2(&rdata->msg_info.via->branch_param, TEST9_BRANCH_ID) == 0) {
 	/*
 	 * The TEST9_BRANCH_ID test failed INVITE transaction with